"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var actionCreators_1 = require("../../actionCreators");
var enums_1 = require("../../enums");
var ComponentUtils_1 = require("../../Utils/ComponentUtils");
var PagingUtils_1 = require("../../Utils/PagingUtils");
var Loading_1 = __importDefault(require("../Loading/Loading"));
var TablePaging_1 = require("../TablePaging/TablePaging");
var TableWrapper_1 = require("../TableWrapper/TableWrapper");
exports.Table = function (props) {
    var _a;
    var childComponents = props.childComponents, dispatch = props.dispatch, height = props.height, loading = props.loading, width = props.width, paging = props.paging, singleAction = props.singleAction;
    var isLoadingActive = loading && loading.enabled;
    var kaCss = isLoadingActive ? 'ka ka-loading-active' : 'ka';
    var _b = ComponentUtils_1.getElementCustomization({
        className: kaCss
    }, props, (_a = childComponents) === null || _a === void 0 ? void 0 : _a.rootDiv), elementAttributes = _b.elementAttributes, rootDivContent = _b.content;
    elementAttributes.style = __assign({ width: width, height: height }, elementAttributes.style);
    React.useEffect(function () {
        if (singleAction) {
            dispatch(singleAction);
            dispatch(actionCreators_1.clearSingleAction());
        }
    });
    return (React.createElement("div", __assign({}, elementAttributes), rootDivContent || (React.createElement(React.Fragment, null,
        PagingUtils_1.isPagingShown(enums_1.PagingPosition.Top, paging) && React.createElement(TablePaging_1.TablePaging, __assign({}, props)),
        React.createElement(TableWrapper_1.TableWrapper, __assign({}, props)),
        PagingUtils_1.isPagingShown(enums_1.PagingPosition.Bottom, paging) && React.createElement(TablePaging_1.TablePaging, __assign({}, props)),
        React.createElement(Loading_1.default, __assign({}, loading))))));
};
