"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DataUtils_1 = require("./DataUtils");
var PropsUtils_1 = require("./PropsUtils");
exports.getRightCell = function (currentCell, props, settings) {
    var _a, _b;
    var nextColumnKey;
    var hasNextColumn = true;
    if ((_a = settings) === null || _a === void 0 ? void 0 : _a.end) {
        nextColumnKey = (_b = props.columns[props.columns.length - 1]) === null || _b === void 0 ? void 0 : _b.key;
    }
    else {
        var columnIndex = props.columns.findIndex(function (c) { return c.key === currentCell.columnKey; });
        hasNextColumn = columnIndex < props.columns.length - 1;
        nextColumnKey = hasNextColumn
            ? props.columns[columnIndex + 1].key
            : currentCell.columnKey;
    }
    return { columnKey: nextColumnKey, rowKeyValue: currentCell.rowKeyValue };
};
exports.getLeftCell = function (currentCell, props, settings) {
    var _a, _b;
    var nextColumnKey;
    var hasNextColumn = true;
    if ((_a = settings) === null || _a === void 0 ? void 0 : _a.end) {
        nextColumnKey = (_b = props.columns[0]) === null || _b === void 0 ? void 0 : _b.key;
    }
    else {
        var columnIndex = props.columns.findIndex(function (c) { return c.key === currentCell.columnKey; });
        hasNextColumn = 0 < columnIndex;
        nextColumnKey = hasNextColumn
            ? props.columns[columnIndex - 1].key
            : currentCell.columnKey;
    }
    return { columnKey: nextColumnKey, rowKeyValue: currentCell.rowKeyValue };
};
exports.getUpCell = function (currentCell, props, settings) {
    var _a, _b;
    var rowKeyValue = currentCell.rowKeyValue;
    var visibleData = PropsUtils_1.getData(props);
    if ((_a = settings) === null || _a === void 0 ? void 0 : _a.end) {
        var nextRow = visibleData[0];
        rowKeyValue = DataUtils_1.getValueByField(nextRow, props.rowKeyField);
    }
    else {
        var rowIndex = (_b = visibleData) === null || _b === void 0 ? void 0 : _b.findIndex(function (d) { return DataUtils_1.getValueByField(d, props.rowKeyField) === currentCell.rowKeyValue; });
        if (rowIndex > 0) {
            var nextRow = visibleData[rowIndex - 1];
            rowKeyValue = DataUtils_1.getValueByField(nextRow, props.rowKeyField);
        }
    }
    return { columnKey: currentCell.columnKey, rowKeyValue: rowKeyValue };
};
exports.getDownCell = function (currentCell, props, settings) {
    var _a, _b;
    var rowKeyValue = currentCell.rowKeyValue;
    var visibleData = PropsUtils_1.getData(props);
    if ((_a = settings) === null || _a === void 0 ? void 0 : _a.end) {
        var nextRow = visibleData[visibleData.length - 1];
        rowKeyValue = DataUtils_1.getValueByField(nextRow, props.rowKeyField);
    }
    else {
        var rowIndex = (_b = visibleData) === null || _b === void 0 ? void 0 : _b.findIndex(function (d) { return DataUtils_1.getValueByField(d, props.rowKeyField) === currentCell.rowKeyValue; });
        if (rowIndex < visibleData.length - 1) {
            var nextRow = visibleData[rowIndex + 1];
            rowKeyValue = DataUtils_1.getValueByField(nextRow, props.rowKeyField);
        }
    }
    return { columnKey: currentCell.columnKey, rowKeyValue: rowKeyValue };
};
