import { AllHTMLAttributes } from 'react';
import { ITableProps } from '../';
import { Column } from '../models';
import { ChildComponent } from '../Models/ChildComponent';
import { ChildAttributesItem, DispatchFunc } from '../types';
export declare function extendProps<T = HTMLElement>(childElementAttributes: AllHTMLAttributes<T>, childProps: any, childComponent?: ChildComponent<any>): React.AllHTMLAttributes<T>;
export declare function mergeProps<T = HTMLElement>(childElementAttributes: AllHTMLAttributes<T>, childProps: any, childCustomAttributes: ChildAttributesItem<any>, dispatch: DispatchFunc): React.AllHTMLAttributes<T>;
export declare const areAllFilteredRowsSelected: (props: ITableProps) => boolean;
export declare const areAllVisibleRowsSelected: (props: ITableProps) => boolean;
export declare const getData: (props: ITableProps) => any[];
export declare const getSelectedData: ({ data, selectedRows, rowKeyField }: ITableProps) => any[];
export declare const getSortedColumns: (props: ITableProps) => Column[];
export declare const getPagesCountByProps: (props: ITableProps) => number;
export declare const prepareTableOptions: (props: ITableProps) => {
    columns: Column[];
    groupColumnsCount: number;
    groupedColumns: Column[];
    groupedData: any[];
};
export declare const getDraggableProps: (key: any, dispatch: DispatchFunc, actionCreator: (draggableKeyValue: any, targetKeyValue: any) => any, draggedClass: string, dragOverClass: string) => ChildAttributesItem<any>;
